/* jinlib.c: fail safe input */
#define VS_JINLIB 240415
#include <stdio.h>
#include <stdlib.h>
#define MB 256
#define BASE 10
#define TEST 0

long int getFixed(void){
	char bb[MB]="\0", *ptr;
	long int k;
	if(fgets(bb,MB,stdin)==NULL)goto err;
	k=strtol(bb, &ptr, BASE);
	if(ptr==bb)goto err;
	return(k);
err: fprintf(stderr,"getFloat(%d): Unable to parse '%s' --> int/n",
	VS_JINLIB,bb); exit(0);		
}
long int getFixedPrompt(char prompt[]){
	long int k;
	fprintf(stdout,"%s",prompt);
	k=getFixed();
	return(k);
}
double getFloat(void){
	char bb[MB]="\0",*ptr;
	double x;
	if(fgets(bb,MB,stdin)==NULL)goto err;
	x=strtof(bb, &ptr);
	if(ptr==bb)goto err;	
	return(x);
err: fprintf(stderr,"getFloat(%d): Unable to parse '%s' --> double/n",
	VS_JINLIB,bb); exit(0);	
}
double getFloatPrompt(char prompt[]){
	double x;
	fprintf(stdout,"%s",prompt);
	x=getFloat();
	return(x);
}
#if TEST!=0
int main(void){
	long int k=getFixed();
	double x=getFloat();
	fprintf(stdout,"%ld, %lf\n",k,x);	
	k=getFixedPrompt("enter fixed-point number>>");
	x=getFloatPrompt("enter floating-point number>>");
	fprintf(stdout,"%ld, %lf\n",k,x);
	return(0);
}
#endif